/*

Concatenate_movies -- A plugin that does what is says
by Jeff Hardin

Created to concatenate a bunch of movies
using QuickTime into a single movie

v. 0.1 - Oct 25, 2006

*/

import ij.*;
import ij.plugin.PlugIn;
import ij.process.*;
import ij.gui.*;
import java.awt.*;
import ij.plugin.*;
import ij.io.*;

import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import java.io.*;
import java.io.IOException;

import javax.swing.*;
import javax.swing.event.*;

import quicktime.*;
import quicktime.util.*;
import quicktime.io.*;
import quicktime.std.movies.*;
import quicktime.std.movies.media.*;
import quicktime.app.view.*;
import quicktime.std.*;


public class Concatenate_movies implements PlugIn,WindowListener,ComponentListener,StdQTConstants,IOConstants  {

public Frame f2;
public Movie m;
public Component c;
public MovieController mc;
public boolean setUpProgressPanel = false;
public JFrame myFrame;
public JLabel myLabel;
public JProgressBar progress;

	public void run(String arg) {
	try
		{
			QTSession.open();
			m = makeMovie();
			String title = "concatenated";
			SaveDialog sd = new SaveDialog("Save QuickTime Movie as...", title, ".mov");
			String dir = sd.getDirectory();
			String name = sd.getFileName();
			String dstFile= dir+name;
			QTFile myQT = new QTFile(dstFile);
			//IJ.showStatus("Flattening movie...");
			
			//Next call was supposed to set the default progress procedure for Movie m, which then shows the
			//progress of the flattening procedure ot the user. This seems to crash about 80% of the time with OS X!
			
			double myQTJVersion = (double) QTBuild.getVersion() +  (double) QTBuild.getSubVersion()/10;
			
			if (!((myQTJVersion >= 6.1) && IJ.isMacOSX())) {m.setProgressProc();}
			//Instead, create our own ProgressProc to provide user feedback via ImageJ's showStatus call...
			else {
			m.setProgressProc(new MovieProgress (){
			public int execute (Movie mov, int message, int whatOperation, float percentDone){
			//IJ.showProgress(percentDone);
			
			if (!setUpProgressPanel){
			// Make a window to display the progress and cancel buttons:
		    progress = new JProgressBar();
			JButton button = new JButton();
		    JPanel topPanel = new JPanel();
			myFrame = new JFrame("Flattening movie...");
		    
		    myFrame.setSize(310, 100);
			topPanel = new JPanel();
			topPanel.setPreferredSize(new Dimension(310, 100));
			myFrame.getContentPane().add(topPanel);
		
			// Create a label and progress bar:
			myLabel = new JLabel("");
			myLabel.setPreferredSize(new Dimension(280, 24));
			myLabel.setForeground(Color.black);
			topPanel.add(myLabel);
		
			progress = new JProgressBar();
			progress.setPreferredSize(new Dimension(300, 20));
			progress.setMinimum(0);
			progress.setMaximum(90);
			progress.setValue(0);
			progress.setBounds(20, 35, 260, 20);
			progress.setForeground(Color.blue);
			topPanel.add(progress);
			myFrame.setVisible(true);
			setUpProgressPanel = true;
			}	
				
				
			//IJ.showStatus("Flattening movie. Percent done: " + (int) (percentDone*100) + "%...");
			myLabel.setText("Flattening movie. Percent done: " + (int) (percentDone*100) + "%...");
			progress.setValue((int) (percentDone*100));
			
			//close progress bar window if done
			if (percentDone == 1){
			//IJ.showStatus("");
			//IJ.showProgress(-1);
			myFrame.dispose();
			}

				//mov + ",message=" + Integer.toHexString(message) + "," + ",what="
				//+ Integer.toHexString(whatOperation)
				//+
				// ",%=" + percentDone);
				//
				return 0;
				}
			}
			
			);
			}
			Movie aMovie = m.flattenData(
			flattenAddMovieToDataFork | 
			flattenForceMovieResourceBeforeMovieData,
			myQT, 1, smSystemScript,
			createMovieFileDeleteCurFile | createMovieFileDontCreateResFile);
			//aMovie.dispose();
			
			//Now open the resulting movie in a player window in ImageJ		 
			mc = new MovieController (m);
            mc.setVisible(true);
            //need the next line to send key events to the movie controller so we can simulate the arrow key functions Apple broke
            mc.setKeysEnabled(true);
            c = QTFactory.makeQTComponent (mc).asComponent();
            c.setName("Controller");
            f2 = new Frame();
            f2.addWindowListener(this);            
			//Component resize is broken under VM 1.4.1 and Panther, so let's not add the listener!
			f2.addComponentListener(this);
            f2.setName("Window");
            BorderLayout myLayout = new BorderLayout();

            //Under Mac OS X and Java 1.4, add a little space at bottom so that 
            //drag box doesn't overlap with right arrow button in movie controller. Way to go, Apple! :-(

            f2.setLayout(myLayout);
            f2.add(c,"Center");
            Panel myPanel = new Panel();
            f2.add(myPanel,"South");
            f2.pack();
            //Under Mac OS X, resize events aren't properly registered, so turn off resizing for now. Arghhh!!!!
			f2.setResizable(true);
			f2.setVisible(true);
			


		}
		catch (Exception e) {
            e.printStackTrace();
		}
	}
	
	    
		     public void windowClosing (WindowEvent e) {
				QTSession.close();
				f2.setVisible(false);
				f2.dispose();
			}			
		     public void windowClosed (WindowEvent e) { 
			}
                        public void windowOpened (WindowEvent e) { 
			}
                        public void windowActivated (WindowEvent e) { 
			}
                        public void windowDeactivated (WindowEvent e) { 
			}
                        public void windowIconified (WindowEvent e) { 
			}
                        public void windowDeiconified (WindowEvent e) { 
			}
			
			 public void componentResized (ComponentEvent e) {}
                    //Seems to be broken for now under Mac OS X and Java 1.4.1 VM; only gets increases in size, but not decreases!
					//IJ.log("Component: " + e.getComponent().getName() + "  New size: " + e.getComponent().getSize().getWidth() + "," + e.getComponent().getSize().getHeight());
                    public void componentHidden (ComponentEvent e) {}
                    public void componentMoved (ComponentEvent e) {}
                    public void componentShown (ComponentEvent e) {}



public Movie makeMovie() throws Exception {
        // create a new, no-tracks movie in memory
         Movie refMovie = new Movie();
         Movie sourceMovie = null;
         int movieTimeScale = 0;
         //int refMovieTimeScale = refMovie.getTimeScale();
		 int refMovieTimeScale = 0;
         int originalMovieDuration = 0;
         int duration = 0;
         int srcDuration = 0;
         int totalDuration = 0;
         int clipStart = 0;
		 int endOutSel = 0;
         String lastClipPath = "";
         File movieFile = null;
         QTFile qtFile = null;
		 int myIndex = 0;
		 String okTypes[] = {".avi",".mov"};
		OpenDialog od = new OpenDialog("Open an AVI...","");
		String dir = od.getDirectory();
		String name = od.getFileName();
		String rootName = "";
		String suffixName = "";
		boolean suffixInList = false;
		int i = 0;

		//IJ.log(dir + name);
		
		//IJ.log("Directory: " + dir1);
		String[] list = new File(dir).list();
		String[] hits = new String[list.length];
		int counter = 0;
		//IJ.log("Parsing file data in the directory...");
		for (i=0; i<list.length; i++) 
		{
			//IJ.log((i+1)+": "+list[i]);
			//IJ.showStatus((i+1) +"/"+list.length);
			//IJ.showProgress((i+1)/list.length);
			File f = new File(dir+list[i]);
			if (!f.isDirectory()) 
			{
				//get the suffix, dude!
				myIndex = list[i].lastIndexOf(".");
				if (myIndex == -1) {
               // IJ.beep();
                IJ.log("Files do not seem to have the correct name structure. Sorry!");
                }
			rootName = list[i].substring(0,myIndex);
			suffixName = list[i].substring(myIndex+1,list[i].length());
            //IJ.log("Root name: " + rootName);
            //IJ.log("Suffix: " + suffixName);
			//now see if it's in the approved list
			suffixInList = false;
			for (int x=0;x<okTypes.length;x++) 
			{
                    //IJ.log("okType = " + okTypes[x] + "; suffixName = " + suffixName);
                    if (("." + suffixName).equalsIgnoreCase(okTypes[x])) 
					{
					 suffixInList = true;
					 //it was in the list! Add the file's name to the hits array...
					 hits[counter] = list[i];
					 counter ++;
					//IJ.log("Name: " + list[i] + ". The file extension was: '" + suffixName + "', which is in the approved list.");
					}
                }//for x
			}//not a directory
		}//for loop		 
		//IJ.log("Counter: " + counter);				 
								 
									 		 
		//int nbrClips = 4;
		int nbrClips = counter;
		String[] clipPath = new String[nbrClips];
		clipPath = hits;
		for (i = 0; i < nbrClips; i++) {
		IJ.log(clipPath[i]);
		}
		/*
		clipPath[0] = dir + name;
		clipPath[1] = dir + "RYANTESTVisuaStack3.avi";
		clipPath[2] = dir + "RYANTESTVisuaStack4.avi";
		clipPath[3] = dir + "RYANTESTVisuaStack5.avi";
		*/

         for (i = 0; i < nbrClips; i++) {
             //String currentClipPath = getClipPath(j); // This gets the source location of the individual clip
			 String currentClipPath = dir + clipPath[i];
			 movieFile = new File(dir + clipPath[i]);
             qtFile = new QTFile(movieFile);
             sourceMovie = Movie.fromFile(OpenMovieFile.asRead(qtFile));
             movieTimeScale = sourceMovie.getTimeScale();
			 //IJ.log("Movie time scale" + (i + 1) + ": " + movieTimeScale);
			 /*
			 if (i == 0 ) {
						refMovie.setTimeScale(movieTimeScale);
						refMovieTimeScale = movieTimeScale; 
						//IJ.log("refMovieTimeScale: " + refMovieTimeScale);
						}
			*/
			
			// Get the ending point of the input movie
			duration = sourceMovie.getDuration();
			// Get the current ending point of the output movie
			endOutSel = refMovie.getDuration();
			// Select all of the input movie
			sourceMovie.setSelection(0,duration);
			// Set the insertion point for the output
			refMovie.setSelection(endOutSel,endOutSel);
			// Paste input into the output
			refMovie.pasteSelection(sourceMovie);


            // originalMovieDuration = sourceMovie.getDuration();
			 //IJ.log("Orig duration " + i + " = " + originalMovieDuration);
             //clipStart = offsets[i]*movieTimeScale; // The individual clips can have a starting offset in an offsets[] int array
			 
             lastClipPath = currentClipPath;
             Thread.currentThread().yield();
         }
		 //zero out selection
		 refMovie.setSelection(0,0);
         return refMovie;

    }

}
